#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, q, n1 = 0;
    cin>>n>>q;
    long long o, p, r, l;
    cin>>o>>p;
    long long a[n], b[n];
    for(int i=0; i<n - 1; i++)
    {
        cin>>r>>l;
        if(o + p >= r)
        {
            p += l;
        }
        else
        {
            a[n1] = o;
            b[n1] = p + o - 1;
            n1++;
            o = r;
            p = l;
        }
    }
    a[n1] = o;
    b[n1] = p + o - 1;
    n1++;


    p = 0;
    r = 0;
    for(int w = 0; w < q; w++)
    {
        cin>>o;
        for(int i = p; i < n1; i++)
        {
            if (a[i] > o)
            {
                cout<<r<<endl;
                break;
            }
            else if (b[i] > o)
            {
                cout<< r + o - a[i] + 1<<endl;
                break;
            }
            else
            {
                r += b[i] - a[i] + 1;
                p = i + 1;
            }
        }
        if (o > b[n1 - 1])
            cout<<r<<endl;
    }


    return 0;
}